This documentation is automatically generated by online-judge-tools/verification-helper
#define PROBLEM "https://judge.yosupo.jp/problem/aplusb"
#include "my_template.hpp"
#include "alg/acted_monoid/summax_assign.hpp"
#include "ds/segtree/dynamic_lazy_segtree.hpp"
#include "random/base.hpp"
void test() {
using AM = ActedMonoid_SumMax_Assign<int, -1>;
using P = typename AM::X;
FOR(100) {
int N = RNG(1, 1000);
vvc<int> AA;
AA.eb(vc<int>(N, 10));
Dynamic_Lazy_SegTree<AM, true> X(30000, 0, N, [](ll l, ll r) -> P { return {10 * (r - l), 10}; });
using np = typename decltype(X)::np;
int Q = RNG(1, 1000);
vc<np> roots;
roots.eb(X.new_node(0, N));
FOR(Q) {
int time = RNG(0, len(roots));
vc<int> A = AA[time];
np root = roots[time];
int L = RNG(0, N);
int R = RNG(0, N);
if (L > R) swap(L, R);
++R;
int t = RNG(0, 4);
if (t == 0) {
int i = RNG(0, N);
int x = RNG(1, 100);
root = X.set(root, i, {x, x});
A[i] = x;
}
if (t == 1) {
vc<int> B = {A.begin() + L, A.begin() + R};
assert(X.prod(root, L, R).fi == SUM<int>(B));
assert(X.prod(root, L, R).se == MAX(B));
}
if (t == 2) {
int x = RNG(1, 100);
FOR(i, L, R) A[i] = x;
root = X.apply(root, L, R, x);
}
if (t == 3) {
// max_right
int LIM = R;
auto check = [&](auto e) -> bool { return e.se <= LIM; };
int naive = [&]() -> int {
ll mx = 0;
FOR(i, L, N) {
chmax(mx, A[i]);
if (mx > LIM) return i;
}
return N;
}();
assert(naive == X.max_right(root, check, L));
}
AA.eb(A);
roots.eb(root);
}
}
}
void solve() {
int a, b;
cin >> a >> b;
cout << a + b << "\n";
}
signed main() {
test();
solve();
return 0;
}
#line 1 "test/1_mytest/dynamic_lazy_segtree_persistent.test.cpp"
#define PROBLEM "https://judge.yosupo.jp/problem/aplusb"
#line 1 "my_template.hpp"
#if defined(LOCAL)
#include <my_template_compiled.hpp>
#else
// https://codeforces.com/blog/entry/96344
// https://codeforces.com/blog/entry/126772?#comment-1154880
#include <bits/allocator.h>
#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2,popcnt")
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using u8 = uint8_t;
using u16 = uint16_t;
using u32 = uint32_t;
using u64 = uint64_t;
using i128 = __int128;
using u128 = unsigned __int128;
using f128 = __float128;
template <class T>
constexpr T infty = 0;
template <>
constexpr int infty<int> = 1'010'000'000;
template <>
constexpr ll infty<ll> = 2'020'000'000'000'000'000;
template <>
constexpr u32 infty<u32> = infty<int>;
template <>
constexpr u64 infty<u64> = infty<ll>;
template <>
constexpr i128 infty<i128> = i128(infty<ll>) * 2'000'000'000'000'000'000;
template <>
constexpr double infty<double> = infty<ll>;
template <>
constexpr long double infty<long double> = infty<ll>;
using pi = pair<ll, ll>;
using vi = vector<ll>;
template <class T>
using vc = vector<T>;
template <class T>
using vvc = vector<vc<T>>;
template <class T>
using vvvc = vector<vvc<T>>;
template <class T>
using vvvvc = vector<vvvc<T>>;
template <class T>
using vvvvvc = vector<vvvvc<T>>;
template <class T>
using pq = priority_queue<T>;
template <class T>
using pqg = priority_queue<T, vector<T>, greater<T>>;
#define vv(type, name, h, ...) vector<vector<type>> name(h, vector<type>(__VA_ARGS__))
#define vvv(type, name, h, w, ...) vector<vector<vector<type>>> name(h, vector<vector<type>>(w, vector<type>(__VA_ARGS__)))
#define vvvv(type, name, a, b, c, ...) \
vector<vector<vector<vector<type>>>> name(a, vector<vector<vector<type>>>(b, vector<vector<type>>(c, vector<type>(__VA_ARGS__))))
// https://trap.jp/post/1224/
#define FOR1(a) for (ll _ = 0; _ < ll(a); ++_)
#define FOR2(i, a) for (ll i = 0; i < ll(a); ++i)
#define FOR3(i, a, b) for (ll i = a; i < ll(b); ++i)
#define FOR4(i, a, b, c) for (ll i = a; i < ll(b); i += (c))
#define FOR1_R(a) for (ll i = (a)-1; i >= ll(0); --i)
#define FOR2_R(i, a) for (ll i = (a)-1; i >= ll(0); --i)
#define FOR3_R(i, a, b) for (ll i = (b)-1; i >= ll(a); --i)
#define overload4(a, b, c, d, e, ...) e
#define overload3(a, b, c, d, ...) d
#define FOR(...) overload4(__VA_ARGS__, FOR4, FOR3, FOR2, FOR1)(__VA_ARGS__)
#define FOR_R(...) overload3(__VA_ARGS__, FOR3_R, FOR2_R, FOR1_R)(__VA_ARGS__)
#define all(x) x.begin(), x.end()
#define len(x) ll(x.size())
#define elif else if
#define eb emplace_back
#define mp make_pair
#define mt make_tuple
#define fi first
#define se second
#define stoi stoll
int popcnt(int x) { return __builtin_popcount(x); }
int popcnt(u32 x) { return __builtin_popcount(x); }
int popcnt(ll x) { return __builtin_popcountll(x); }
int popcnt(u64 x) { return __builtin_popcountll(x); }
int popcnt_sgn(int x) { return (__builtin_parity(unsigned(x)) & 1 ? -1 : 1); }
int popcnt_sgn(u32 x) { return (__builtin_parity(x) & 1 ? -1 : 1); }
int popcnt_sgn(ll x) { return (__builtin_parityll(x) & 1 ? -1 : 1); }
int popcnt_sgn(u64 x) { return (__builtin_parityll(x) & 1 ? -1 : 1); }
// (0, 1, 2, 3, 4) -> (-1, 0, 1, 1, 2)
int topbit(int x) { return (x == 0 ? -1 : 31 - __builtin_clz(x)); }
int topbit(u32 x) { return (x == 0 ? -1 : 31 - __builtin_clz(x)); }
int topbit(ll x) { return (x == 0 ? -1 : 63 - __builtin_clzll(x)); }
int topbit(u64 x) { return (x == 0 ? -1 : 63 - __builtin_clzll(x)); }
// (0, 1, 2, 3, 4) -> (-1, 0, 1, 0, 2)
int lowbit(int x) { return (x == 0 ? -1 : __builtin_ctz(x)); }
int lowbit(u32 x) { return (x == 0 ? -1 : __builtin_ctz(x)); }
int lowbit(ll x) { return (x == 0 ? -1 : __builtin_ctzll(x)); }
int lowbit(u64 x) { return (x == 0 ? -1 : __builtin_ctzll(x)); }
template <typename T>
T kth_bit(int k) {
return T(1) << k;
}
template <typename T>
bool has_kth_bit(T x, int k) {
return x >> k & 1;
}
template <typename UINT>
struct all_bit {
struct iter {
UINT s;
iter(UINT s) : s(s) {}
int operator*() const { return lowbit(s); }
iter &operator++() {
s &= s - 1;
return *this;
}
bool operator!=(const iter) const { return s != 0; }
};
UINT s;
all_bit(UINT s) : s(s) {}
iter begin() const { return iter(s); }
iter end() const { return iter(0); }
};
template <typename UINT>
struct all_subset {
static_assert(is_unsigned<UINT>::value);
struct iter {
UINT s, t;
bool ed;
iter(UINT s) : s(s), t(s), ed(0) {}
int operator*() const { return s ^ t; }
iter &operator++() {
(t == 0 ? ed = 1 : t = (t - 1) & s);
return *this;
}
bool operator!=(const iter) const { return !ed; }
};
UINT s;
all_subset(UINT s) : s(s) {}
iter begin() const { return iter(s); }
iter end() const { return iter(0); }
};
template <typename T>
T floor(T a, T b) {
return a / b - (a % b && (a ^ b) < 0);
}
template <typename T>
T ceil(T x, T y) {
return floor(x + y - 1, y);
}
template <typename T>
T bmod(T x, T y) {
return x - y * floor(x, y);
}
template <typename T>
pair<T, T> divmod(T x, T y) {
T q = floor(x, y);
return {q, x - q * y};
}
template <typename T, typename U>
T SUM(const vector<U> &A) {
T sm = 0;
for (auto &&a: A) sm += a;
return sm;
}
#define MIN(v) *min_element(all(v))
#define MAX(v) *max_element(all(v))
#define LB(c, x) distance((c).begin(), lower_bound(all(c), (x)))
#define UB(c, x) distance((c).begin(), upper_bound(all(c), (x)))
#define UNIQUE(x) sort(all(x)), x.erase(unique(all(x)), x.end()), x.shrink_to_fit()
template <typename T>
T POP(deque<T> &que) {
T a = que.front();
que.pop_front();
return a;
}
template <typename T>
T POP(pq<T> &que) {
T a = que.top();
que.pop();
return a;
}
template <typename T>
T POP(pqg<T> &que) {
T a = que.top();
que.pop();
return a;
}
template <typename T>
T POP(vc<T> &que) {
T a = que.back();
que.pop_back();
return a;
}
template <typename F>
ll binary_search(F check, ll ok, ll ng, bool check_ok = true) {
if (check_ok) assert(check(ok));
while (abs(ok - ng) > 1) {
auto x = (ng + ok) / 2;
(check(x) ? ok : ng) = x;
}
return ok;
}
template <typename F>
double binary_search_real(F check, double ok, double ng, int iter = 100) {
FOR(iter) {
double x = (ok + ng) / 2;
(check(x) ? ok : ng) = x;
}
return (ok + ng) / 2;
}
template <class T, class S>
inline bool chmax(T &a, const S &b) {
return (a < b ? a = b, 1 : 0);
}
template <class T, class S>
inline bool chmin(T &a, const S &b) {
return (a > b ? a = b, 1 : 0);
}
// ? は -1
vc<int> s_to_vi(const string &S, char first_char) {
vc<int> A(S.size());
FOR(i, S.size()) { A[i] = (S[i] != '?' ? S[i] - first_char : -1); }
return A;
}
template <typename T, typename U>
vector<T> cumsum(vector<U> &A, int off = 1) {
int N = A.size();
vector<T> B(N + 1);
FOR(i, N) { B[i + 1] = B[i] + A[i]; }
if (off == 0) B.erase(B.begin());
return B;
}
// stable sort
template <typename T>
vector<int> argsort(const vector<T> &A) {
vector<int> ids(len(A));
iota(all(ids), 0);
sort(all(ids), [&](int i, int j) { return (A[i] == A[j] ? i < j : A[i] < A[j]); });
return ids;
}
// A[I[0]], A[I[1]], ...
template <typename T>
vc<T> rearrange(const vc<T> &A, const vc<int> &I) {
vc<T> B(len(I));
FOR(i, len(I)) B[i] = A[I[i]];
return B;
}
template <typename T, typename... Vectors>
void concat(vc<T> &first, const Vectors &... others) {
vc<T> &res = first;
(res.insert(res.end(), others.begin(), others.end()), ...);
}
#endif
#line 2 "alg/monoid/summax.hpp"
template <typename E>
struct Monoid_SumMax {
using value_type = pair<E, E>;
using X = value_type;
static X op(X x, X y) { return {x.fi + y.fi, max(x.se, y.se)}; }
static X from_element(E e) { return {e, e}; }
static constexpr X unit() { return {E(0), -infty<E>}; }
static constexpr bool commute = 1;
};
#line 2 "alg/monoid/assign.hpp"
template <typename X, int none_val>
struct Monoid_Assign {
using value_type = X;
static X op(X x, X y) { return (y == X(none_val) ? x : y); }
static constexpr X unit() { return X(none_val); }
static constexpr bool commute = false;
};
#line 3 "alg/acted_monoid/summax_assign.hpp"
template <typename E, E none_val>
struct ActedMonoid_SumMax_Assign {
using Monoid_X = Monoid_SumMax<E>;
using Monoid_A = Monoid_Assign<E, none_val>;
using X = typename Monoid_X::value_type;
using A = typename Monoid_A::value_type;
static constexpr X act(const X& x, const A& a, const ll& size) {
if (a == Monoid_A::unit()) return x;
return {E(size) * a, a};
}
};
#line 2 "ds/segtree/dynamic_lazy_segtree.hpp"
// Q*4logN 程度必要? apply で 4logN ノード作っていると思う
template <typename ActedMonoid, bool PERSISTENT>
struct Dynamic_Lazy_SegTree {
using AM = ActedMonoid;
using MX = typename AM::Monoid_X;
using MA = typename AM::Monoid_A;
using X = typename AM::X;
using A = typename AM::A;
using F = function<X(ll, ll)>;
F default_prod;
struct Node {
Node *l, *r;
X x;
A lazy;
};
const int NODES;
const ll L0, R0;
Node *pool;
int pid;
using np = Node *;
Dynamic_Lazy_SegTree(
int NODES, ll L0, ll R0, F default_prod = [](ll, ll) -> X { return MX::unit(); })
: default_prod(default_prod), NODES(NODES), L0(L0), R0(R0), pid(0) {
pool = new Node[NODES];
}
~Dynamic_Lazy_SegTree() { delete[] pool; }
np new_root() { return new_node(L0, R0); }
np new_node(const X x) {
assert(pid < NODES);
pool[pid].l = pool[pid].r = nullptr;
pool[pid].x = x;
pool[pid].lazy = MA::unit();
return &(pool[pid++]);
}
np new_node(ll l, ll r) {
assert(l < r);
return new_node(default_prod(l, r));
}
np new_node() { return new_node(L0, R0); }
np new_node(const vc<X> &dat) {
assert(L0 == 0 && R0 == len(dat));
auto dfs = [&](auto &dfs, ll l, ll r) -> Node * {
if (l == r) return nullptr;
if (r == l + 1) return new_node(dat[l]);
ll m = (l + r) / 2;
np l_root = dfs(dfs, l, m), r_root = dfs(dfs, m, r);
X x = MX::op(l_root->x, r_root->x);
np root = new_node(x);
root->l = l_root, root->r = r_root;
return root;
};
return dfs(dfs, 0, len(dat));
}
X prod(np root, ll l, ll r) {
if (l == r || !root) return MX::unit();
assert(pid && L0 <= l && l < r && r <= R0);
X x = MX::unit();
prod_rec(root, L0, R0, l, r, x, MA::unit());
return x;
}
X prod_all(np root) { return prod(root, L0, R0); }
np set(np root, ll i, const X &x) {
assert(pid && L0 <= i && i < R0);
return set_rec(root, L0, R0, i, x);
}
np multiply(np root, ll i, const X &x) {
assert(pid && L0 <= i && i < R0);
return multiply_rec(root, L0, R0, i, x);
}
np apply(np root, ll l, ll r, const A &a) {
if (l == r) return root;
assert(pid && L0 <= l && l < r && r <= R0);
return apply_rec(root, L0, R0, l, r, a);
}
template <typename F>
ll max_right(np root, F check, ll L) {
assert(pid && L0 <= L && L <= R0 && check(MX::unit()));
X x = MX::unit();
return max_right_rec(root, check, L0, R0, L, x);
}
template <typename F>
ll min_left(np root, F check, ll R) {
assert(pid && L0 <= R && R <= R0 && check(MX::unit()));
X x = MX::unit();
return min_left_rec(root, check, L0, R0, R, x);
}
// f(idx, val)
template <typename F>
void enumerate(np root, F f) {
auto dfs = [&](auto &dfs, np c, ll l, ll r, A a) -> void {
if (!c) return;
if (r - l == 1) {
f(l, AM::act(c->x, a, 1));
return;
}
ll m = (l + r) / 2;
a = MA::op(c->lazy, a);
dfs(dfs, c->l, l, m, a);
dfs(dfs, c->r, m, r, a);
};
dfs(dfs, root, L0, R0, MA::unit());
}
void reset() { pid = 0; }
// root[l:r) を apply(other[l:r),a) で上書きしたものを返す
np copy_interval(np root, np other, ll l, ll r, A a) {
if (root == other) return root;
root = copy_node(root);
copy_interval_rec(root, other, L0, R0, l, r, a);
return root;
}
private:
np copy_node(np c) {
if (!c || !PERSISTENT) return c;
pool[pid].l = c->l, pool[pid].r = c->r;
pool[pid].x = c->x;
pool[pid].lazy = c->lazy;
return &(pool[pid++]);
}
void prop(np c, ll l, ll r) {
assert(r - l >= 2);
ll m = (l + r) / 2;
if (c->lazy == MA::unit()) return;
c->l = (c->l ? copy_node(c->l) : new_node(l, m));
c->l->x = AM::act(c->l->x, c->lazy, m - l);
c->l->lazy = MA::op(c->l->lazy, c->lazy);
c->r = (c->r ? copy_node(c->r) : new_node(m, r));
c->r->x = AM::act(c->r->x, c->lazy, r - m);
c->r->lazy = MA::op(c->r->lazy, c->lazy);
c->lazy = MA::unit();
}
void copy_interval_rec(np c, np d, ll l, ll r, ll ql, ll qr, A a) {
// c[ql,qr) <- apply(d[ql,qr),a)
// もう c は新しくしてある
assert(c);
chmax(ql, l), chmin(qr, r);
if (ql >= qr) return;
if (l == ql && r == qr) {
if (d) {
c->x = AM::act(d->x, a, r - l), c->lazy = MA::op(d->lazy, a);
c->l = d->l, c->r = d->r;
} else {
c->x = AM::act(default_prod(l, r), a, r - l), c->lazy = a;
c->l = nullptr, c->r = nullptr;
}
return;
}
// push
ll m = (l + r) / 2;
c->l = (c->l ? copy_node(c->l) : new_node());
c->r = (c->r ? copy_node(c->r) : new_node());
c->l->x = AM::act(c->l->x, c->lazy, m - l);
c->l->lazy = MA::op(c->l->lazy, c->lazy);
c->r->x = AM::act(c->r->x, c->lazy, r - m);
c->r->lazy = MA::op(c->r->lazy, c->lazy);
c->lazy = MA::unit();
if (d) a = MA::op(d->lazy, a);
copy_interval_rec(c->l, (d && d->l ? d->l : nullptr), l, m, ql, qr, a);
copy_interval_rec(c->r, (d && d->r ? d->r : nullptr), m, r, ql, qr, a);
c->x = MX::op(c->l->x, c->r->x);
return;
}
np set_rec(np c, ll l, ll r, ll i, const X &x) {
if (r == l + 1) {
c = copy_node(c);
c->x = x;
c->lazy = MA::unit();
return c;
}
prop(c, l, r);
ll m = (l + r) / 2;
if (!c->l) c->l = new_node(l, m);
if (!c->r) c->r = new_node(m, r);
c = copy_node(c);
if (i < m) {
c->l = set_rec(c->l, l, m, i, x);
} else {
c->r = set_rec(c->r, m, r, i, x);
}
c->x = MX::op(c->l->x, c->r->x);
return c;
}
np multiply_rec(np c, ll l, ll r, ll i, const X &x) {
if (r == l + 1) {
c = copy_node(c);
c->x = MX::op(c->x, x);
c->lazy = MA::unit();
return c;
}
prop(c, l, r);
ll m = (l + r) / 2;
if (!c->l) c->l = new_node(l, m);
if (!c->r) c->r = new_node(m, r);
c = copy_node(c);
if (i < m) {
c->l = multiply_rec(c->l, l, m, i, x);
} else {
c->r = multiply_rec(c->r, m, r, i, x);
}
c->x = MX::op(c->l->x, c->r->x);
return c;
}
void prod_rec(np c, ll l, ll r, ll ql, ll qr, X &x, A lazy) {
chmax(ql, l);
chmin(qr, r);
if (ql >= qr) return;
if (!c) {
x = MX::op(x, AM::act(default_prod(ql, qr), lazy, qr - ql));
return;
}
if (l == ql && r == qr) {
x = MX::op(x, AM::act(c->x, lazy, r - l));
return;
}
ll m = (l + r) / 2;
lazy = MA::op(c->lazy, lazy);
prod_rec(c->l, l, m, ql, qr, x, lazy);
prod_rec(c->r, m, r, ql, qr, x, lazy);
}
np apply_rec(np c, ll l, ll r, ll ql, ll qr, const A &a) {
if (!c) c = new_node(l, r);
chmax(ql, l);
chmin(qr, r);
if (ql >= qr) return c;
if (l == ql && r == qr) {
c = copy_node(c);
c->x = AM::act(c->x, a, r - l);
c->lazy = MA::op(c->lazy, a);
return c;
}
prop(c, l, r);
ll m = (l + r) / 2;
c = copy_node(c);
c->l = apply_rec(c->l, l, m, ql, qr, a);
c->r = apply_rec(c->r, m, r, ql, qr, a);
c->x = MX::op(c->l->x, c->r->x);
return c;
}
template <typename F>
ll max_right_rec(np c, const F &check, ll l, ll r, ll ql, X &x) {
if (r <= ql) return r;
if (!c) c = new_node(l, r);
chmax(ql, l);
if (l == ql && check(MX::op(x, c->x))) {
x = MX::op(x, c->x);
return r;
}
if (r == l + 1) return l;
prop(c, l, r);
ll m = (l + r) / 2;
ll k = max_right_rec(c->l, check, l, m, ql, x);
if (k < m) return k;
return max_right_rec(c->r, check, m, r, ql, x);
}
template <typename F>
ll min_left_rec(np c, const F &check, ll l, ll r, ll qr, X &x) {
if (qr <= l) return l;
if (!c) c = new_node(l, r);
chmin(qr, r);
if (r == qr && check(MX::op(c->x, x))) {
x = MX::op(c->x, x);
return l;
}
if (r == l + 1) return r;
prop(c, l, r);
ll m = (l + r) / 2;
ll k = min_left_rec(c->r, check, m, r, qr, x);
if (m < k) return k;
return min_left_rec(c->l, check, l, m, qr, x);
}
};
#line 2 "random/base.hpp"
u64 RNG_64() {
static u64 x_ = u64(chrono::duration_cast<chrono::nanoseconds>(chrono::high_resolution_clock::now().time_since_epoch()).count()) * 10150724397891781847ULL;
x_ ^= x_ << 7;
return x_ ^= x_ >> 9;
}
u64 RNG(u64 lim) { return RNG_64() % lim; }
ll RNG(ll l, ll r) { return l + RNG_64() % (r - l); }
#line 6 "test/1_mytest/dynamic_lazy_segtree_persistent.test.cpp"
void test() {
using AM = ActedMonoid_SumMax_Assign<int, -1>;
using P = typename AM::X;
FOR(100) {
int N = RNG(1, 1000);
vvc<int> AA;
AA.eb(vc<int>(N, 10));
Dynamic_Lazy_SegTree<AM, true> X(30000, 0, N, [](ll l, ll r) -> P { return {10 * (r - l), 10}; });
using np = typename decltype(X)::np;
int Q = RNG(1, 1000);
vc<np> roots;
roots.eb(X.new_node(0, N));
FOR(Q) {
int time = RNG(0, len(roots));
vc<int> A = AA[time];
np root = roots[time];
int L = RNG(0, N);
int R = RNG(0, N);
if (L > R) swap(L, R);
++R;
int t = RNG(0, 4);
if (t == 0) {
int i = RNG(0, N);
int x = RNG(1, 100);
root = X.set(root, i, {x, x});
A[i] = x;
}
if (t == 1) {
vc<int> B = {A.begin() + L, A.begin() + R};
assert(X.prod(root, L, R).fi == SUM<int>(B));
assert(X.prod(root, L, R).se == MAX(B));
}
if (t == 2) {
int x = RNG(1, 100);
FOR(i, L, R) A[i] = x;
root = X.apply(root, L, R, x);
}
if (t == 3) {
// max_right
int LIM = R;
auto check = [&](auto e) -> bool { return e.se <= LIM; };
int naive = [&]() -> int {
ll mx = 0;
FOR(i, L, N) {
chmax(mx, A[i]);
if (mx > LIM) return i;
}
return N;
}();
assert(naive == X.max_right(root, check, L));
}
AA.eb(A);
roots.eb(root);
}
}
}
void solve() {
int a, b;
cin >> a >> b;
cout << a + b << "\n";
}
signed main() {
test();
solve();
return 0;
}